function set_noise
%========================================================================

%Copyright (c) 1999-2000 The University of Texas
%All Rights Reserved.
 
%This program is free software; you can redistribute it and/or modify
%it under the terms of the GNU General Public License as published by
%the Free Software Foundation; either version 2 of the License, or
%(at your option) any later version.
 
%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.
 
%The GNU Public License is available in the file LICENSE, or you
%can write to the Free Software Foundation, Inc., 59 Temple Place -
%Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
%World Wide Web at http://www.fsf.org.

 %Demo ideas : Dr.Alan C Bovik
 %Programmer :	Umesh Rajashekar 
 %Version:        %W%	%G%

%The authors are with the Department of Electrical and Computer
%Engineering, The University of Texas at Austin, Austin, TX.
%They can be reached at bovik@ece.utexas.edu and umesh@ece.utexas.edu

%Kindly report any suggestions or corrections to the demos to 
%umesh@ece.utexas.edu

%========================================================================
%adds the proper noise to the signal
%===================================

list_hndl = findobj(gcbf,'Tag','list_noise');
val = get(list_hndl,'Value');
names = get(list_hndl,'String');
noise_type = names{val};
%--------------------------------------

%getting slider handles
low_hndl  = findobj(gcbf,'Tag','slider_low');
high_hndl = findobj(gcbf,'Tag','slider_high');

%--------------------------------------
%read the signal
hndl = findobj(gcbf , 'Tag' , 'push_select');
sig_info = get(hndl,'Userdata');
sig = sig_info.data;

noise = rand(size(sig));
noise = (noise - 0.5)*.25;
noise_eg = rand(size(sig));%used as an eg of the noise spec later...
									% in the filter determination
noise_eg = (noise_eg-0.5)*0.25;

n1 = noise_eg;

switch noise_type
   
case 'White'
   set(low_hndl,'Enable','off');
   set(high_hndl,'Enable','off');
      
case 'Colored'
   set(low_hndl,'Enable','on');
   set(high_hndl,'Enable','on');
   low = floor(get(low_hndl,'Value')*10)/10; 
   high =floor(get(high_hndl,'Value')*10)/10;
   
   %bandpass this noise
   %-------------------
   
   %make bandpass filt
   [b a ] = butter(10,[low high]);
%  figure(2);
%  freqz(b,a);
   noise = filter(b,a,noise);
   noise_eg = filter(b,a,noise_eg);
end


%figure(3);
%subplot(2,1,1),psd(n1);
%subplot(2,1,2),psd(noise_eg);

sig = sig+noise;
sig_info.data = sig;

%save noisy signal data in push button for noisy
hndl = findobj(gcbf,'Tag','push_noisy');
set(hndl,'Userdata',sig_info);

%------------------------------------------

%store the eg noise in the list box for psd_type
hndl = findobj(gcbf,'Tag','list_psd');
set(hndl,'Userdata',noise_eg);
